/*
 * wrapconnection.hxx
 *
 * OpenH323 Wrapper Library
 *
 * Copyright (c) 2002,2003 InAccess Networks
 * Michalis Manousos <manousos@inaccessnetworks.com>
 * Dimitris Economou <decon@inaccessnetworks.com>
 *
 * This file is part of "H.323 support for ASTERISK"
 *
 * "H.323 support for ASTERISK" is free software;
 * you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation;
 * either version 2 of the License, or (at your option) any later version. 
 *
 * "H.323 support for ASTERISK" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: wrapconnection.hxx,v 1.11 2003/11/20 16:22:20 manousos Exp $
 *
 */

//////////////////////////////////////////////////////////////////////////

#ifndef	_WRAPCONNECTION_HXX
#define	_WRAPCONNECTION_HXX

// Backlog (pending unanswered incoming calls)
#define	MAX_UNANSWERED_CALL_NUM		5

/**
 * The wrapper descentant of the H323Connection class
 */
class WrapH323Connection : public H323Connection {

	PCLASSINFO(WrapH323Connection, H323Connection);

	public:
	WrapH323Connection(WrapH323EndPoint &, unsigned);
	~WrapH323Connection();

	H323Connection::AnswerCallResponse OnAnswerCall(const PString &, 
						const H323SignalPDU &, H323SignalPDU &);
	BOOL OnAlerting(const H323SignalPDU &, const PString &);
	BOOL OnReceivedSignalSetup(const H323SignalPDU &);
	void OnReceivedReleaseComplete(const H323SignalPDU &);
	BOOL OnSendSignalSetup(H323SignalPDU &);
	void OnEstablished();
	BOOL OnClosingLogicalChannel(H323Channel &);
	BOOL OnControlProtocolError(ControlProtocolErrors, const void *);
	BOOL OnReceivedFacility(const H323SignalPDU &);
	//BOOL OnCreateLogicalChannel(const H323Capability &, H323Channel::Directions, unsigned &);
	//H323Channel *CreateRealTimeLogicalChannel(const H323Capability &, H323Channel::Directions, unsigned, const H245_H2250LogicalChannelParameters *);
	//H323Channel *CreateLogicalChannel(const H245_OpenLogicalChannel &, BOOL, unsigned &);
	BOOL RequestModeChange(const PString &);
	BOOL OnRequestModeChange(const H245_RequestMode &, H245_RequestModeAck &, 
			H245_RequestModeReject &, PINDEX &);
	void OnModeChanged(const H245_ModeDescription &);
	void OnAcceptModeChange(const H245_RequestModeAck &);
	void OnRefusedModeChange(const H245_RequestModeReject *);

	PString sourceAliases;
	PString destAliases;
	PString sourceE164;
	PString destE164;
	//H323Channel *pChannel;
};

#endif	// _WRAPCONNECTION_HXX
// End of file //////////////////////////////////////////////////////////////
